<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import DefaultTemplate from '~/components/solutions/templates/default-template.vue';
import IndustryTemplate from '~/components/solutions/templates/industry-template.vue';

import { getPageMetadata } from '~/common/meta';
import { TEMPLATES } from '~/common/constants';

export default Vue.extend({
  components: {
    DefaultTemplate,
    IndustryTemplate,
  },
  async asyncData({ $solutionsService, params, error }: any) {
    try {
      const isIndexSlug = !params.slug;
      const solutions = await $solutionsService.getContent(
        `solutions/value-stream-management${
          params.slug ? `/${params.slug}` : ''
        }`,
        isIndexSlug,
      );

      return { solutions };
    } catch (e) {
      console.error(e);
      error({ statusCode: 404 });
      return {};
    }
  },
  data() {
    return {
      TEMPLATES,
    };
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).solutions, this.$route.path);
  },
});
</script>

<template>
  <industry-template
    v-if="solutions.template === TEMPLATES.Industry"
    :solutions="solutions"
  />
  <default-template v-else :solutions="solutions" />
</template>
